diff --git a/src/utils/os_divers.c b/src/utils/os_divers.c
index fef591ef6f..130f64e126 100644
--- a/src/utils/os_divers.c
+++ b/src/utils/os_divers.c
@@ -1990,6 +1990,11 @@ GF_Err gf_bin128_parse(const char *string, bin128 value)
 			sscanf(szV, "%x", &v);
 			value[i] = v;
 			i++;
+			if (i > 15) {
+				// force error check below
+				i++;
+				break;
+			}
 		}
 	}
 	if (i != 16) {
